#!BPY

""" Registration info for Blender menus: <- these words are ignored
Name: 'Vertex Aligner'
Blender: 242
Group: 'Mesh'
Tip: 'Vertex Aligner'
"""

__author__ = "Keines"
__url__ = ("blender", "elysiun", "My HomePage, http://keines.gozaru.jp/blender/index.html")
__version__ = "2007.02.25(Sun) 02:39"

__bpydoc__ = """\
How to ..

1 Select  Vertex
2 Push @ Button or Input X,Y,Z
3 Execute

"""

import Blender
from Blender import Draw,BGL,Object,Window

# + Variables
Title		= 'Vertex Aligner'
Author		= ' by '+__author__
VerWidth	= Draw.GetStringWidth(__version__+Author)
MainWidth	= VerWidth+Draw.GetStringWidth(Title)

# + BaseValue
SpcWidth	= 20
BaseHeight	= 20
BtnHeight	= 20
ValueRange	= 8000.00   # -10000 - 10000.0

ToggleStr	= ["All Vertices","Select Only"]
LogicalStr	= ["-","+"]

# + Label
MainLabel	= [['X',0],['Y',0],['Z',0],[ToggleStr[0],0],['@',0],[LogicalStr[0],0],['3D Cursor',0],['Execute',0],['Exit',0]]
MainLabel_X	= 0
MainLabel_Y	= 1
MainLabel_Z	= 2
MainLabel_Select= 3
MainLabel_Now	= 4
MainLabel_Logical=5
MainLabel_Cursor= 6
MainLabel_Execute=7
MainLabel_Exit	= 8

for i in range(len(MainLabel)):
    MainLabel[i][1]=Draw.GetStringWidth(MainLabel[i][0])+SpcWidth
NumberBtnWidth = Draw.GetStringWidth(MainLabel[MainLabel_X][0]+str(ValueRange))+SpcWidth*2

MainLabel[MainLabel_Logical][1]-=10

# + Source Button [Toggle,Number]
BtnList=[[Draw.Create(1),Draw.Create(0.0)],
	 [Draw.Create(1),Draw.Create(0.0)],
	 [Draw.Create(1),Draw.Create(0.0)]
	]
BtnList_Toggle	= 0
BtnList_Number	= 1

BtnSelect=Draw.Create(1)

# Event
Event_None	= 0
Event_ReDraw	= 1
Event_Now	= 2
Event_NowX	= 3
Event_NowY	= 4
Event_NowZ	= 5
Event_LogX	= 6
Event_LogY	= 7
Event_LogZ	= 8
Event_Cursor	= 9
Event_Execute	= 10
Event_Exit	= 11

def CursorFunction():
  loc=Blender.Window.GetCursorPos()
  for i in range(3):
    if BtnList[i][0].val:
      loc[i]=BtnList[i][1].val
  Blender.Window.SetCursorPos(loc[0],loc[1],loc[2])
  Blender.Redraw()

def AlignFunction():
    # + First Init
    IsEditMode=0
    if Blender.Window.EditMode() :
      IsEditMode+=1
      Blender.Window.EditMode(0)
    
    OB = Blender.Object.GetSelected()[0]
    if OB.getType()=='Mesh':
      ME=OB.getData(mesh=1)		# mesh=1 ȂƍWȊO( hide Ƃ )
      if ME!=None:
	IsAlignX=BtnList[0][0].val
	IsAlignY=BtnList[1][0].val
	IsAlignZ=BtnList[2][0].val
	x=BtnList[0][1].val
	y=BtnList[1][1].val
	z=BtnList[2][1].val
	if BtnSelect.val==1:
          for vert in ME.verts:
            if (vert.sel==1) :
	      if (IsAlignX==1):vert.co[0]=x
	      if (IsAlignY==1):vert.co[1]=y
	      if (IsAlignZ==1):vert.co[2]=z
	else:
          for vert in ME.verts:
	    if (IsAlignX==1):vert.co[0]=x
	    if (IsAlignY==1):vert.co[1]=y
	    if (IsAlignZ==1):vert.co[2]=z
        ME.update()
    
    if IsEditMode :
      Blender.Window.EditMode(1)
    Blender.Redraw()
    Draw.Register(DrawGui, KeyEvent, ButtonEvent)

def NowItFunction(IsX,IsY,IsZ):
    # + First Init
    IsEditMode=0
    if Blender.Window.EditMode() :
      IsEditMode+=1
      Blender.Window.EditMode(0)
    
    OB = Blender.Object.GetSelected()[0]
    if OB.getType()=='Mesh':
      ME=OB.getData()
      if ME!=None:
	x=BtnList[0][1].val
	y=BtnList[1][1].val
	z=BtnList[2][1].val
        for vert in ME.verts:
          if (vert.sel==1) :
	    if (IsX==1):x=vert.co[0]
	    if (IsY==1):y=vert.co[1]
	    if (IsZ==1):z=vert.co[2]
	    BtnList[0][1].val=x
	    BtnList[1][1].val=y
	    BtnList[2][1].val=z
	    break
    if IsEditMode :
      Blender.Window.EditMode(1)
    Blender.Redraw()
    Draw.Register(DrawGui, KeyEvent, ButtonEvent)

def DrawGui():
    global BtnList,BtnSelect
    
    # --- Init Screen ---
    BGL.glClearColor(0.6, 0.6, 0.6, 0.0)
    BGL.glClear(Blender.BGL.GL_COLOR_BUFFER_BIT)
    BGL.glColor3f(0.1, 0.1, 0.15) # Text Color
    # --- Get Screen Size ---
    size=Blender.BGL.Buffer(Blender.BGL.GL_FLOAT, 4)
    Blender.BGL.glGetFloatv(Blender.BGL.GL_SCISSOR_BOX, size)
    size= size.list
    # FLOAT -> INT
    for s in range(4): size[s]=int(size[s])
    # Base Position
    x=20
    y=size[3]-BaseHeight
    # + Title
    BGL.glRasterPos2f(x, y)
    Draw.Text(Title)
    
    k=MainLabel[MainLabel_Execute][1]+SpcWidth
    MaxWidth=x+2*(NumberBtnWidth+6)+SpcWidth+MainLabel[MainLabel_Execute][1]
    
    y-=BaseHeight*2
    BtnSelect=Draw.Toggle(ToggleStr[BtnSelect.val],Event_ReDraw,x,y,MainLabel[MainLabel_Select][1],BtnHeight,BtnSelect.val)
    Draw.Button (MainLabel[MainLabel_Now][0],Event_Now,x+MainLabel[2][1]+4+NumberBtnWidth+4,y,MainLabel[MainLabel_Now][1]-4,BaseHeight,"")
    
    y-=BaseHeight+8
    
    h=BtnHeight+4
    for i in range(MainLabel_X+3):
      BtnList[i][0]=Draw.Toggle(MainLabel[i][0],Event_ReDraw,x,y-(h*i),MainLabel[i][1],BtnHeight,BtnList[i][0].val)
      if (BtnList[i][0].val==1):
        BtnList[i][1]=Draw.Number('',Event_ReDraw,x+MainLabel[i][1]+4,y-(h*i),NumberBtnWidth, BtnHeight, BtnList[i][1].val, -ValueRange, ValueRange)
        Draw.Button (MainLabel[MainLabel_Now][0],Event_NowX+i,x+MainLabel[i][1]+4+NumberBtnWidth+4,y-(h*i),MainLabel[MainLabel_Now][1]-4,BaseHeight,"")
        Draw.Button (LogicalStr[BtnList[i][1].val<0],Event_LogX+i,MaxWidth-MainLabel[MainLabel_Logical][1],y-(h*i),MainLabel[MainLabel_Logical][1],BaseHeight,"")
        BGL.glRasterPos2f(MaxWidth-k, y-(h*i)+6)
        Draw.Text("%.03f"%BtnList[i][1].val)
    
    y-=BaseHeight*4+10
    # + Btn Cursor / Execute
    Draw.Button (MainLabel[MainLabel_Cursor][0] ,Event_Cursor,x,y,MainLabel[MainLabel_Cursor][1],BaseHeight,"")
    Draw.Button (MainLabel[MainLabel_Execute][0],Event_Execute,MaxWidth-k,y,k,BaseHeight,"")
    
    # + Version
    y-=BaseHeight+6
    #x=20
    BGL.glRasterPos2f(MaxWidth-VerWidth, y)
    Draw.Text(__version__+Author)
    
    # + Exit Button
    y-=BaseHeight+6
    Draw.Button (MainLabel[MainLabel_Exit][0],Event_Exit,x,y,MainLabel[MainLabel_Exit][1]+SpcWidth,BaseHeight,"")

def ButtonEvent(evt):
    if  (evt==Event_Execute): AlignFunction()
    elif (evt==Event_Cursor): CursorFunction()
    elif (evt==Event_ReDraw): Draw.Register(DrawGui, KeyEvent, ButtonEvent)
    elif (evt==Event_Now)   : NowItFunction(BtnList[0][0].val,BtnList[1][0].val,BtnList[2][0].val)
    elif (evt==Event_NowX)  : NowItFunction(1,0,0)
    elif (evt==Event_NowY)  : NowItFunction(0,1,0)
    elif (evt==Event_NowZ)  : NowItFunction(0,0,1)
    elif evt in [Event_LogX,Event_LogY,Event_LogZ]  :
      BtnList[evt-Event_LogX][1].val*=-1
      Draw.Register(DrawGui, KeyEvent, ButtonEvent)
    elif (evt==Event_Exit)  : Draw.Exit()

def KeyEvent(evt, val):
    # val: 1=KeyDown 0=KeyUp
    if (not val) : return
    if evt in [Draw.ESCKEY, Draw.QKEY]: Draw.Exit()

Draw.Register(DrawGui, KeyEvent, ButtonEvent)
